; Note-It 1.0
; Robert Gerlach 6.2003
; www.robsite.de
;
; Ein kleiner Editor der ber allen Fenstern steht.
; Fr kleine Notizen und schnelles editieren von Zeug.
; Rechte Maustaste: Copy/Paste/Select All, New/Open/Save, Font whlen, 'Right Below' (in die rechte untere Ecke stellen)  und 'Always on top' an- und ausschalten

; Gadgets dem Fenster-Resize anpassen 
Procedure WindowResize(WindowID, Message, wParam, lParam) 
    Result = #PB_ProcessPureBasicEvents 
    If Message = #WM_SIZE
        
      ww = WindowWidth()
      wh = WindowHeight()
      
      ; RichEdit
      ResizeRichEdit(100,1,1,ww-2,wh-2)
      
          
    ReturnValue = 1
    EndIf
    ProcedureReturn Result 
EndProcedure


If FileSize("prefs.dat") = -1
  If OpenFile(0,"prefs.dat")
    WriteStringN("Courier New")
    WriteStringN("8")
    fontname.s = "Courier New"
    fontsize.l = 8
  EndIf
Else
  If OpenFile(0,"prefs.dat")
    fontname.s = ReadString()
    fontsize.l = Val(ReadString())
  EndIf
EndIf


ww=200
wh=100
screen_x = GetSystemMetrics_(#SM_CXSCREEN) 
screen_y = GetSystemMetrics_(#SM_CYSCREEN)
screen_y_usable = getsystemmetrics_(#SM_CYMAXIMIZED)
cymin = getsystemmetrics_(#SM_CYMIN)
cxborder = getsystemmetrics_(#SM_CXEDGE)

OpenWindow(0,0,0,ww,wh,#pb_window_systemmenu | #pb_window_screencentered | #pb_window_maximizegadget | #pb_window_minimizegadget | #pb_window_sizegadget, "Note-It")
SetWindowPos_(WindowID(),#HWND_TOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE)


CreatePopupMenu(0)
  MenuItem(1,"Copy")
  MenuItem(2,"Paste")
  MenuItem(3,"Select All")
  MenuBar()
  MenuItem(4,"New")
  MenuItem(5,"Open")
  MenuItem(6,"Save")
  MenuBar()
  MenuItem(7,"Font")
  MenuItem(8,"Right below")
  MenuItem(9,"Always on top")
  
  SetMenuItemState(0,9,1)


RichEditOptions(#WS_CHILD | #WS_VISIBLE | #WS_VSCROLL |  #ES_MULTILINE | #ES_AUTOVSCROLL)
If OpenRichEdit(WindowID(),100,1,1,ww-2,wh-2,"") = 0 : MessageRequester("Error","Konnte RichEdit1 nicht ffnen",0) : EndIf 
RichEditFont(100,fontname, -1, -1, fontsize, 0, 0, 0, 0)

SetWindowCallback(@WindowResize())

ActivateRichEdit(100) ; Sofort schreibbereit, Cursor blinkt


Repeat
  eventid = WaitWindowEvent()

  Select eventid
    
    Case #pb_event_menu

      Select EventMenuID()
        Case 1
          SendMessage_(getfocus_(), #WM_COPY, 0, 0)
        Case 2
          SendMessage_(getfocus_(), #WM_PASTE, 0, 0)
          SelectText(0,-1) ; Alles auswhlen
          RichEditFont(100,"Courier New", RGB(0,0,0), -1, 8, 0, 0, 0, 0) ; Alles klein und schwarz
          SelectText(-1,-1) ; Deselektieren
        Case 3
          SelectText(0,-1)
          
          
        Case 4
          SetRichEditText(100,0,-1,"")
        
        
        Case 5 ; ffnen
          datei.s = OpenFileRequester("Open","","Text *.txt | *.txt| Alle Dateien *.* | *.*",1)
          StreamFileIn(datei, #SF_TEXT)

        Case 6 ; Speichern
          datei.s = SaveFileRequester("Save","","Text *.txt | *.txt| Alle Dateien *.* | *.*",1)
          pos = FindString(datei, ".", 1) 
          If pos = 0 : datei + ".txt" : EndIf
          
          If FileSize(datei) > -1
            overwrite = MessageRequester("Overwrite?",datei + " already exists."+Chr(10)+"Do you want to replace it?",#PB_MessageRequester_YesNo)
            If overwrite = 6         
              StreamFileOut(datei, #SF_TEXT)
            EndIf
          Else
            StreamFileOut(datei, #SF_TEXT)
          EndIf 
        
        
        Case 7 ; Font whlen
          ; Erst den Text sichern, da die Schriftart nur gendert wird, wenn das RichEdit leer ist o_O' 
          ; Dadurch ist die Gre des Inhalts auf 64KB beschrnkt, wenn man unbedingt die Schriftart ndern will...
          text.s = GetRichEditText(100,0,100)
          font = FontRequester(fontname,fontsize,#PB_FontRequester_Effects)
          fontname = SelectedFontName() ; Man kann beim ersten FontRequester()-Aufruf nicht SelectedFontname() verwenden, da dieses noch keinen Wert hat --> Absturz
          fontsize = SelectedFontSize() 
          
          SetRichEditText(100,0,-1,"")
          RichEditFont(100,SelectedFontName(), SelectedFontColor(), -1, SelectedFontSize(), 0, 0, 0, 0) ; Alles klein und schwarz
          SetRichEditText(100,0,-1,text)
          
          ; Font in prefs.dat speichern
          CloseFile(0)
          DeleteFile("prefs.dat") ; (Inhalt der) Datei lschen
          OpenFile(0,"prefs.dat") 
          WriteStringN(fontname)
          WriteStringN(Str(fontsize))
       
        Case 8 ; Fenster rechts unten Positionieren
          MoveWindow(screen_x - ww - (cxborder*4), screen_y - wh - (cymin*2))
              
          
        Case 9 ; Immer im Vordergrund?
          If GetMenuItemState(0,9) ; N
            SetWindowPos_(WindowID(),#HWND_NOTOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE)
            SetMenuItemState(0,9,0)
          Else ; Ja
            SetWindowPos_(WindowID(),#HWND_TOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE)
            SetMenuItemState(0,9,1)
          EndIf 

      
      EndSelect       

    Case #WM_RButtonDown
      DisplayPopupMenu(0,WindowID()) ; Popup anzeigen
  EndSelect 

Until eventid = #pb_eventclosewindow

CloseFile(0)

; ExecutableFormat=Windows
; CursorPosition=134
; FirstLine=108
; UseIcon=D:\PureBasic\EigeneProgramme\note-it.ico
; Executable=D:\PureBasic\EigeneProgramme\note-it.exe
; EOF